﻿using System;
using System.IO;
using System.Media;
using Styx.Common;
using Styx.CommonBot;
using Styx.Plugins;

namespace GliderSounds
{
    public class GliderSounds : HBPlugin
    {
        private SoundPlayer _player;

        public override void Pulse()
        {
        }

        public override string Name
        {
            get { return "Glider Sounds"; }
        }

        public override string Author
        {
            get { return "aevitas"; }
        }

        public override Version Version
        {
            get { return new Version(1, 0, 9); }
        }

        public override void OnEnable()
        {
            Attach();

            BotEvents.Player.OnMobKilled += MobKilled;
            BotEvents.OnBotStopped += BotStop;
            Chat.Whisper += Whisper;
            BotEvents.Player.OnPlayerDied += PlayerDeath;
        }

        private void PlayerDeath()
        {
            PlaySoundFile("PlayerAttack.wav");
        }

        private void BotStop(EventArgs args)
        {
            PlaySoundFile("GlideStop.wav");
        }

        private void Whisper(Chat.ChatWhisperEventArgs chatWhisperEventArgs)
        {
            PlaySoundFile("Whisper.wav");
        }

        public override void OnDisable()
        {
            BotEvents.Player.OnMobKilled -= MobKilled;
            BotEvents.OnBotStopped -= BotStop;
            Chat.Whisper -= Whisper;
            BotEvents.Player.OnPlayerDied -= PlayerDeath;
        }

        private void PlaySoundFile(string file)
        {
            _player = new SoundPlayer(Path.Combine(Utilities.AssemblyDirectory, "Sounds", file));
            _player.Play();
        }

        private void MobKilled(BotEvents.Player.MobKilledEventArgs args)
        {
            PlaySoundFile("Kill.wav");
        }

        private void Attach()
        {
            PlaySoundFile("Attach.wav");
        }
    }
}
